/*
	Type codes:
		0 = text
		1 = <B>		11 = </B>		( bold )
		2 = <EM>	12 = </EM>		( emphasis )
		3 = <I>		13 = </I>		( italic )
		4 = <PL>	14 = </PL>		( plain )
		5 = <S>		15 = </S>		( strong )
		6 = <TT>	16 = </TT>		( typewriter )
		7 = <U>		17 = </U>		( underline level )
		20 = <r>	30 = </r>		( red )
		21 = <g>	31 = </g>		( green )
		22 = <b>	32 = </b>		( blue )
		23 = <c>	33 = </c>		( cyan )
		24 = <m>	34 = </m>		( magenta )
		25 = <y>	35 = </y>		( yellow )
		26 = <k>	36 = </k>		( black )
		27 = <w>	37 = </w>		( white )
		40 = <0>	50 = </0>		( font size)
		 ...		  ...
		49 = <9>	59 = </9>		( font size)
 */

struct doc_node
{
	struct doc_node* next;
	struct doc_node* prev;
	short type;		// see above codes
	struct mc_string* text;
};

int is_text(struct doc_node* a);
int is_opentag(struct doc_node* a);
int is_closetag(struct doc_node* a);

struct doc_node* delete_tag(struct doc_node* a);

struct doc_node* scan_input();
void print_output(struct doc_node* a);

