struct statestack
{
	struct statestack* up;
	struct statestack* down;
	long level;
	char flags;
	char u_level;
	short size;
	char color;
	char tag_deleted;
};


struct statestack* newstack();
struct statestack* newstate(struct statestack* a);
struct statestack* restorestate(struct statestack* a);
short equivstates(struct statestack* a, struct statestack* b);

void set_b(struct statestack* a);
void clear_b(struct statestack* a);
short test_b(struct statestack* a);

void toggle_em(struct statestack* a);
void clear_em(struct statestack* a);
short test_em(struct statestack* a);

void set_i(struct statestack* a);
void clear_i(struct statestack* a);
short test_i(struct statestack* a);

void set_s(struct statestack* a);
void clear_s(struct statestack* a);
short test_s(struct statestack* a);

void set_tt(struct statestack* a);
void clear_tt(struct statestack* a);
short test_tt(struct statestack* a);

void inc_u(struct statestack* a);
void clear_u(struct statestack* a);
short test_u(struct statestack* a);

void set_size(struct statestack* a,short newsize);
short get_size(struct statestack* a);

void set_color(struct statestack* a,char newcolor);
short get_color(struct statestack* a);
